<script setup>
import BookItem from './BookItem.vue'

import { onMounted, ref } from 'vue'

const data = ref(null)
const error = ref(null)

fetch ('https://api.mangaUpdate.fr/api/getBooks', {
  method: 'POST',
  headers: {'Content-Type' : 'application/json'},
  body: JSON.stringify({
    'token':sessionStorage.getItem('authentificated')
  })
}).then((res) => res.json())
  .then((json) => {(data.value = json); console.log(data._rawValue)})
  .catch((err) => (error.value = err))

  function title_voir_website(e){
    let elm = e.target;
    console.log(elm)
    let liste_div = document.getElementById('menu_voir_websites').lastElementChild;
    liste_div.setAttribute('class', 'flex flex-col');
    liste_div.innerText = "";
    console.log(data._rawValue[elm.getAttribute('data_index')])
    Array.from(data._rawValue[elm.getAttribute('data_index')].link).forEach(link => {
      let elm_liste_websites = document.createElement('div');
      elm_liste_websites.innerHTML = '<a href="'+link.link+'" target="_blank" class="flex mb-4 p-4 bg-gray-500 rounded">\
                                        <h3>'+link.website+'</h3>\
                                      </a>'
      liste_div.appendChild(elm_liste_websites)
    })
  }

  function chapter_voir_website(e){
    let elm = e.target;
    console.log(elm)
    let liste_div = document.getElementById('menu_voir_websites').lastElementChild;
    liste_div.setAttribute('class', 'flex flex-col');
    liste_div.innerText = "";
    Array.from(data._rawValue[elm.getAttribute('data_index')].chapter[elm.getAttribute('data_indexchapter')].links).forEach(link => {
      let elm_liste_websites = document.createElement('div');
      elm_liste_websites.innerHTML = '<a href="'+link.link+'" target="_blank" class="flex mb-4 p-4 bg-gray-500 rounded">\
                                        <h3>'+link.website+'</h3>\
                                      </a>'
      liste_div.appendChild(elm_liste_websites)
    })
  }

  function toggle_favorite(e){
    let elm = e.target.classList.contains('favorite_toggle') ? e.target : e.target.parentElement
    fetch ('https://api.mangaUpdate.fr/api/book/toggleFavorite', {
      method: 'POST',
      headers: {'Content-Type' : 'application/json'},
      body: JSON.stringify({
        'token':sessionStorage.getItem('authentificated'),
        'id':data._rawValue[elm.getAttribute('data_index')].id
      })
    }).then((res) => res.json())
      .then((json) => {json == 'book is favorite' ? data.value[elm.getAttribute('data_index')].favorite = true : json == 'book is not favorite' ? data.value[elm.getAttribute('data_index')].favorite = false : console.log(json);})
      .catch((err) => (error.value = err))
    
  }

  function delete_follow_book(e){
    let elm = e.target.classList.contains('delete_icon') ? e.target : e.target.parentElement
    fetch ('https://api.mangaUpdate.fr/api/book/removeFollowBook', {
      method: 'POST',
      headers: {'Content-Type' : 'application/json'},
      body: JSON.stringify({
        'token':sessionStorage.getItem('authentificated'),
        'id':data._rawValue[elm.getAttribute('data_index')].id
      })
    }).then((res) => res.json())
      .then((json) => location.reload())
      .catch((err) => (error.value = err))
  }

  let touch_position = [];
  let elm_position_initial = [];

  function init_touch_position(e){
    let book = e.target;
    while(!book.classList.contains('my_book')){
      book = book.parentElement;
    }
    console.log(book.firstElementChild.firstElementChild)
    touch_position[book.firstElementChild.firstElementChild.getAttribute('data_index')] = e.targetTouches[0].pageX;
    if(book.style.left == ''){
      book.style.left = '0px';
    }
    elm_position_initial[book.firstElementChild.firstElementChild.getAttribute('data_index')] = book.style.left.substring(0, book.style.left.length - 2);
  }

  function book_slide(e){
    let book = e.target;
    while(!book.classList.contains('my_book')){
      book = book.parentElement;
    }

    if(elm_position_initial[book.firstElementChild.firstElementChild.getAttribute('data_index')] == 0){
      if(e.targetTouches[0].pageX - touch_position[book.firstElementChild.firstElementChild.getAttribute('data_index')] <= 80 
        && e.targetTouches[0].pageX - touch_position[book.firstElementChild.firstElementChild.getAttribute('data_index')] > -100){   
          book.style.left = (e.targetTouches[0].pageX - touch_position[book.firstElementChild.firstElementChild.getAttribute('data_index')]) + 'px' ;
      }
    }else{
      if(e.targetTouches[0].pageX - touch_position[book.firstElementChild.firstElementChild.getAttribute('data_index')] <= 180 
        && e.targetTouches[0].pageX - touch_position[book.firstElementChild.firstElementChild.getAttribute('data_index')] > -180){   
          book.style.left = parseInt(elm_position_initial[book.firstElementChild.firstElementChild.getAttribute('data_index')]) + (e.targetTouches[0].pageX - touch_position[book.firstElementChild.firstElementChild.getAttribute('data_index')]) + 'px' ;
      }
    }
  }

  function book_end_slide(e){
    let book = e.target;
    while(!book.classList.contains('my_book')){
      book = book.parentElement;
    }
    if(book.style.left.substring(0, book.style.left.length - 2) >= 60){
      book.style.left = 60 + 'px';
    }else if(book.style.left.substring(0, book.style.left.length - 2) <= -60){
      book.style.left = '-80px';
    }else{
      book.style.left = '0';
    }
  }

  function update_current_chapter(e){
	let elm = e.target;
	console.log(elm, elm.value)
    fetch ('https://api.mangaUpdate.fr/api/bookUser/updateCurrentChapter', {
      method: 'POST',
      headers: {'Content-Type' : 'application/json'},
      body: JSON.stringify({
        'token':sessionStorage.getItem('authentificated'),
        'id':data._rawValue[elm.getAttribute('data_index')].id,
		'value':elm.value
      })
    }).then((res) => res.json())
      .then((json) => console.log(json))
      .catch((err) => (error.value = err))
  }

</script>

<template>
  <div id="liste_books" class="w-full">

    <div v-if="error" class="error">{{ error }}</div>

    <div v-else-if="data" class="content lg:grid lg:gap-2 lg:grid-cols-2 xl:grid-cols-3 2xl:grid-cold-4">
      <li class="list-none my_book" draggable="true" @touchmove="book_slide" @touchstart="init_touch_position" @touchend="book_end_slide" v-for="(book, index) in data">
        <BookItem>
          <template #delete>
            <font-awesome-icon class="absolute h-8 my-0 mx-4 right-full delete_icon text-red-800 lg:hidden" icon="fa-solid fa-trash-can" v-bind:data_index="index" @click="delete_follow_book"/>
          </template>
          <template #image>
            <img v-bind:src="book.image.replace('asura.gg', 'asuratoon.com')" alt="image_livre" class="w-1/3 me-3">
          </template>
          <template #name>
            <label v-if="book.link.length > 1" for="voir_websites" @click="title_voir_website" v-bind:data_index="index">
              {{ book.name }}
            </label>
            <a v-else-if="book.link.length == 1" v-bind:href="book.link[0].link" target="_blank">
              {{ book.name }}
            </a>
            <p v-else>
              {{ book.name }}
            </p>
          </template>
          <template #chapters>
              <li v-for="(chapter, indexChapter) in book.chapter">
                <label for="voir_websites" v-if="chapter.links.length > 1" @click="chapter_voir_website" v-bind:data_index="index" v-bind:data_indexchapter="indexChapter">
                  {{ (chapter.number).toString().includes('chapter') ? chapter.number : 'Ch.' + chapter.number }}
                </label>
                <a v-else-if="chapter.links.length == 1" v-bind:href="chapter.links[0].link" target="_blank">
                  {{ (chapter.number).toString().includes('chapter') ? chapter.number : 'Ch.' + chapter.number }}
                </a>
                <p v-else>
                  {{ (chapter.number).toString().includes('chapter') ? chapter.number : 'Ch.' + chapter.number }}
                </p>
              </li>
          </template>
          <template #currentChapter>
              <label v-bind:for="'select_chapter_'+book.name">Chapitre actuel</label>
              <select v-bind:id="'select_chapter_'+book.name" class="bg-gray-600 rounded" v-bind:data_index="index" @change="update_current_chapter">
                  <option v-if="book.currentChapter == ''" value="" selected></option>
                  <option v-else value=""></option>
                  <template v-for="(chapter, indexChapter) in book.chapter">
                      <option v-if="chapter.number == book.currentChapter" selected :value="chapter.number">
                          {{ chapter.number }}
                      </option>
                      <option v-else :value="chapter.number">
                          {{ chapter.number }}
                      </option>
                  </template>
              </select>
          </template>
          <template #icons>
            <font-awesome-icon class="hidden h-8 delete_icon text-red-800 lg:block lg:cursor-pointer" icon="fa-solid fa-trash-can" v-bind:data_index="index" @click="delete_follow_book"/>
            <font-awesome-icon v-if="book.favorite" class="hidden h-8 my-4 favorite_toggle lg:block lg:cursor-pointer" icon="fa-solid fa-star" v-bind:data_index="index" @click="toggle_favorite"/>
            <font-awesome-icon v-else class="hidden h-8 my-4 favorite_toggle lg:block lg:cursor-pointer" icon="fa-regular fa-star" v-bind:data_index="index" @click="toggle_favorite"/>
          </template>
          <template #favourite>
              <font-awesome-icon v-if="book.favorite" class="absolute h-10 my-0 mx-4 left-full favorite_toggle lg:hidden" icon="fa-solid fa-star" v-bind:data_index="index" @click="toggle_favorite"/>
              <font-awesome-icon v-else class="absolute h-10 my-0 mx-4 left-full favorite_toggle lg:hidden" icon="fa-regular fa-star" v-bind:data_index="index" @click="toggle_favorite"/>
          </template>
        </BookItem>
      </li>
    </div>
    <div v-else="loading" class="loading">Loading...</div>
  </div>
</template>